package com.ibm.rcp.security.icard.test;

import javax.security.auth.login.LoginException;

import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

import com.ibm.rcp.accounts.Account;
import com.ibm.rcp.security.auth.AuthProperties;

/**
 * The activator class controls the plug-in life cycle
 */
public class Activator extends AbstractUIPlugin {

	// The plug-in ID
	public static final String PLUGIN_ID = "com.ibm.rcp.security.icard.test";

	// The shared instance
	private static Activator plugin;
	
	/**
	 * The constructor
	 */
	public Activator() {
		plugin = this;
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		testAccount();
	}
	
	private void testAccount(){
		Account account = new Account();
		account.setAuthType("I-CARD");
		account.setName("icard-test");
		account.setType("HTTP");
		account.setProperty("tokenType", 
			"http://docs.oasis-open.org/wss/oasis-wss-saml-token-profile-1.1#SAMLV1.1");
		account.setProperty("requiredClaims", 
			"http://schemas.xmlsoap.org/ws/2005/05/identity/claims/emailaddress " +
			"http://schemas.xmlsoap.org/ws/2005/05/identity/claims/privatepersonalidentifier");
		account.setProperty("optionalClaims", 
			"http://schemas.xmlsoap.org/ws/2005/05/identity/claims/givenname " + 
			"http://schemas.xmlsoap.org/ws/2005/05/identity/claims/surname");
		account.setProperty(AuthProperties.SERVER, "http://localhost");
		try {
			account.getLoginContext().login();
		} catch (LoginException e) {
			e.printStackTrace();
		}
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
	}

	/**
	 * Returns the shared instance
	 *
	 * @return the shared instance
	 */
	public static Activator getDefault() {
		return plugin;
	}

}
